#include "mbed.h"

AnalogIn ain(A0);                           // Analog input at PA0
uint32_t mysum;                             // Used for summation

int main()
{
    printf("\r\n Lab03_analog_thermometer - with averaging\r\n");
    while(1) {
        mysum = 0;
        for(int i=0; i<3300; i++) {
            mysum += ain.read_u16();        // sum up raw 16-bit data
        }
        float voltage = mysum>>16;       // voltage in millivolts
        float tempC = (voltage - 500)/10; // tempereature in Celsius
        printf(" voltage: %5.0f mV temp: %5.1f °C\r\n",voltage,tempC);
        wait(2);
    }
}